<?php

//
// This example uses the database created by the diagram from example 2.
// It allows you to edit the database contents.
//
// NOTE: You may easily edit another database by modifying the tables array
//  below.
//

session_start();

if	($action == "zap")
{
	session_destroy();
	unset($action);
}

if	($action == "kill")
{
	session_destroy();
	echo "<A HREF='?action='>You may create a new session</A>";
	exit(0);
}

require_once ("d2p_manager.inc");
require_once ("d2p_data.inc");
require_once ("Exemple2_classes.inc");

$tables = array(
	"ta", "tb", "tc", "td", "te", "tf", "th", "tb_ta_link", "tc_td_link"
);


if	(!session_is_registered("table"))
{
	$table = $tables[0];
	session_register("table");
	$stlist = join(",", $tables);
	session_register("stlist");
}
elseif	(strcmp($stlist, join(",", $tables)))
{
	$table = $tables[0];
	$stlist = join(",", $tables);
}
if	(isset($ntable) && !(array_search($ntable, $tables, true) === FALSE))
	$table = $ntable;


echo "Tables : ";
foreach ($tables as $t)
{
	echo "<A HREF='?ntable=$t'>$t</A> ";
}
echo "<BR/>";
echo "TABLE BEING EDITED : $table<BR/>";
echo "<A HREF='?action=zap'>Reset session</A> - <A HREF='?action=kill'>Kill session</A><BR/><BR/>";


//$pg = @pg_connect("host=dbhost dbname=dbname user=dbuser password=dbpass");
$pg = @pg_connect("dbname=tseeker user=tseeker");
if	(!$pg)
{
	echo "Unable to connect\n";
	exit(1);
}
$d2pManager = new d2p_manager($pg);


if	(!isset($action) || $action == "" || !strcmp($action, "list"))
{
	$tab = $d2pManager->listFromBase($table, "SELECT * FROM \"$table\"");
?>
<FORM METHOD='post'>
 <INPUT TYPE='hidden' NAME='action' VALUE='edit' />
 <TABLE>
  <TR>
   <TD>
<?php
	if	(!is_array($tab) || count($tab) < 1)
	{
		echo "No record found\n";
	}
	else
	{
?>
    <SELECT NAME='identifier'>
<?php
		for	($i=0;$i<count($tab);$i++)
		{
			$idn = $tab[$i]->getIdentifier();
			echo "     <OPTION VALUE=\"";
			if	(is_array($idn))
			{
				$tmp = array();
				foreach ($idn as $fn => $fv)
				{
					array_push($tmp, $fn);
					if	(is_object($idn[$fn]))
						array_push($tmp, $tab[$i]->fields[$fn]["current_value"]);
					else
						array_push($tmp, $fv);
				}
				echo join(",", $tmp);
			}
			else
				echo $idn;
			echo "\">" . $tab[$i]->getDescription() . "</OPTION>\n";
		}
?>
    </SELECT>
   </TD>
   <TD>
    <INPUT TYPE='submit' VALUE='edit' />
<?php
	}
?>
   </TD>
   <TD>
    <A HREF='?action=new'>Create new record</A>
   </TD>
  </TR>
 </TABLE>
</FORM>
<?php
	if	(is_array($tab) && count($tab) > 0)
	{
?>
<HR/>
<TABLE BORDER='1'>
 <TR>
<?php
		foreach	($tab[0]->fields as $fn => $f)
		{
			echo "  <TH>$fn</TH>\n";
		}
?>
 </TR>
<?php
		for	($i=0;$i<count($tab);$i++)
		{
			echo " <TR>\n";
			foreach	($tab[$i]->fields as $fn => $f)
			{
				if	($f["references"])
				{
					$obj2 = $tab[$i]->getField($fn);
					if	(is_object($obj2) && $obj2->isLoaded)
						$tmp = $obj2->getDescription();
				}
				else
					$tmp = $f["current_value"];

				echo "  <TD>" . ($tmp != "" ? $tmp : "&nbsp;") . "</TD>\n";
			}
			echo " </TR>\n";
		}
	}
}
elseif	(!strcmp($action, "new"))
{
	$obj = $d2pManager->newObject($table);
	echo "<FORM METHOD='post'>\n";
	echo "<INPUT TYPE='hidden' NAME='action' VALUE='create' />\n";
	echo "<TABLE>\n";
	echo $obj->getHTMLForm();
	echo "</TABLE>\n";
	echo "<INPUT TYPE='submit' VALUE='create record' />\n";
	echo "</FORM>\n";
}
elseif	(!strcmp($action, "edit") && isset($identifier))
{
	$obj = $d2pManager->newObject($table);
	$idn = $obj->getIdentifierName();
	if	(is_array($idn))
	{
		$av = explode(",", $identifier);
		$tmp = array();
		for	($i=0;$i<count($av);$i+=2)
			$tmp[$av[$i]] = $av[$i+1];
		$obj = $d2pManager->objectFromBase($table, $tmp);
	}
	else
		$obj = $d2pManager->objectFromBase($table, $identifier);
	if	(is_object($obj))
	{
		echo "<FORM METHOD='post'>\n";
		echo "<INPUT TYPE='hidden' NAME='action' VALUE='modify' />\n";
		echo "<TABLE>\n";
		echo $obj->getHTMLForm();
		echo "</TABLE>\n";
		echo "<INPUT TYPE='submit' VALUE='modify' />\n";
		echo "<INPUT TYPE='submit' NAME='DELETE' VALUE='delete record' />\n";
		echo "</FORM>\n";
	}
	else
	{
		echo "<FONT COLOR='red'>Unable to find the object with the $identifier identifier</FONT>";
		exit(0);
	}
}
elseif	(!strcmp($action, "create"))
{
	$obj = $d2pManager->newObject($table);
	$obj->getFormInput();
	if	($d2pManager->commit())
	{
		echo "<TABLE>\n";
		echo "<TR><TD ALIGN='CENTER'>NEW RECORD CREATED</TD></TR>\n";
		echo "<TR><TD ALIGN='RIGHT'><A HREF='?action=list'>Back to the list</A></TD></TR>\n";
		echo "</TABLE>\n";
	}
	else
	{
		echo "<FONT COLOR='red'>An error has occured ; the record was not created</FONT><BR/>\n";
		echo "<FORM METHOD='post'>\n";
		echo "<INPUT TYPE='hidden' NAME='action' VALUE='create' />\n";
		echo "<TABLE>\n";
		echo $obj->getHTMLForm();
		echo "</TABLE>\n";
		echo "<INPUT TYPE='submit' VALUE='create new record' />\n";
		echo "</FORM>\n";
	}
}
elseif	(!strcmp($action, "modify"))
{
	$obj = $d2pManager->objectFromForm($table);

	if	(isset($DELETE))
		$obj->destroy();
	if	($d2pManager->commit())
	{
		if	(!$DELETE)
		{
			echo "<FORM METHOD='post'>\n";
			echo "<INPUT TYPE='hidden' NAME='action' VALUE='modify' />\n";
			echo "<TABLE>\n";
			echo "<TR><TD ALIGN='CENTER' COLSPAN='2'>THE RECORD HAS BEEN UPDATED</TD></TR>\n";
			echo $obj->getHTMLForm();
			echo "</TABLE>\n";
			echo "<INPUT TYPE='submit' VALUE='modify' />\n";
			echo "<INPUT TYPE='submit' NAME='DELETE' VALUE='delete record' />\n";
			echo "</FORM>\n";
		}
		else
		{
			echo "Record destroyed<BR/>";
			echo "<A HREF='?action=list'>Back to the list</A>\n";
		}
	}
	else
	{
		echo "<FONT COLOR='red'>An error has occured ; the record was not updated</FONT><BR/>\n";
		echo "<FORM METHOD='post'>\n";
		echo "<INPUT TYPE='hidden' NAME='action' VALUE='modify' />\n";
		echo "<TABLE>\n";
		echo $obj->getHTMLForm();
		echo "</TABLE>\n";
		echo "<INPUT TYPE='submit' VALUE='modify' />\n";
		echo "<INPUT TYPE='submit' NAME='DELETE' VALUE='delete record' />\n";
		echo "</FORM>\n";
	}
}


?>
